# TP 08 correction : Tri
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

# fichier à compléter intégrant tous les tests

#%% ne pas exécuter
# ou ne pas tenir compte de l'erreur

if __name__ == "__main__":
    raise RuntimeError("Exécuter les cellules")

#%% exercice 1

# classique ! à savoir faire sans aide !
def est_croissante(L):
    n = len(L)
    for i in range(n-1):
        if L[i+1] < L[i]:
            return False
    return True

# test
L = [2, 6, 7, 7, 9, 15]
print("L =", L)
print(est_croissante(L))
M = [1, 8, 3, 2, 4, 25]
print("M =", M)
print(est_croissante(M))

#%% exercice 2

def maximum(L):
    n = len(L)
    assert n != 0, "le maximum d'une liste vide n'est pas défini"
    # au départ le maximum supposé ne peut être que...
    M = L[0]
    # parcourir la liste
    for i in range(1, n):
        # L[i] est-il le nouveau maximum ?
        if L[i] > M:
            M = L[i]
    return M

# test
L = [10, 1, 5, 6, 7, 5]
print("L =", L)
print(maximum(L))
M = [1, 1, 5, 6, 9, 5]
print("M =", M)
print(maximum(M))
N = [1, 8, 6, 8, 8, 12]
print("N =", N)
print(maximum(N))

#%% exercice 3

def ordonne(L, i, j):
    # s'ils ne sont pas dans le bon ordre...
    if (i < j and L[i] > L[j]) or (j < i and L[j] > L[i]):
        # échanger les éléments d'indice i et j
        x = L[i]
        L[i] = L[j]
        L[j] = x
    return L

# test
L = [1, 8, 3, 2, 1, 25]
print("L =", L)
i = 1
j = 2
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
i = 3
j = 5
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
i = 4
j = 2
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
# continuer
i = 1
j = 2
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
i = 2
j = 3
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)

#%% exercice 4

def tri_bulle(L):
    n = len(L)
    # répéter le bon nombre de fois
    for i in range(n-1):
        # parcourir la liste et ordonner, si nécessaire, deux éléments consécutifs
        for j in range(n-1):
            if L[j+1] < L[j]:
                x = L[j]
                L[j] = L[j+1]
                L[j+1] = x
    return L

L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_bulle(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_bulle(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_bulle(N))

#%% bonus
# rajouter des print dans la boucle (créer une fonction tri_bulle_print) et observer le résultat

def tri_bulle_print(L):
    n = len(L)
    # répéter le bon nombre de fois
    for i in range(n-1):
        # parcourir la liste et ordonner, si nécessaire, deux éléments consécutifs
        for j in range(n-1):
            print(L)
            if L[j+1] < L[j]:
                x = L[j]
                L[j] = L[j+1]
                L[j+1] = x
    return L

L = [5, 4, 3, 2, 1]
tri_bulle_print(L)

#%% exercice 5

def tri_selection(L):
    n = len(L)
    # placer l'élément d'indice i, pour chaque i
    for i in range(n-1):
        # chercher l'indice du minimum de la liste à partir de l'indice i, inclus
        imin = i
        for j in range(i+1, n):
            if L[j] < L[imin]:
                imin = j
        # échanger les éléments d'indices i et imin
        x = L[i]
        L[i] = L[imin]
        L[imin] = x
    return L

# test
L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_selection(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_selection(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_selection(N))

#%% exercice 6

def tri_insertion(L):
    n = len(L)
    # répéter : prendre l'élément d'indice i et l'insérer à sa place parmi les i premiers éléments
    for i in range(1, n):
        x = L[i]
        # décaler vers la droite les éléments d'indice de 0 à i-1 tant qu'ils sont plus grands que x
        j = i - 1
        while j >= 0 and L[j] > x:
            L[j+1] = L[j]
            j = j - 1
        # insérer x à l'indice j
        j = j + 1
        L[j] = x
    return L

# test
L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_insertion(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_insertion(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_insertion(N))

#%% exercice 7

# import ?
from random import randrange

def tri_stupide(L):
    n = len(L)
    # tant que ce n'est pas fini
    while not est_croissante(L):
        # choisir des indices au hasard
        i = randrange(n)
        j = randrange(n)
        ordonne(L, i, j)
    return L

L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_stupide(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_stupide(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_stupide(N))

#%% bonus
# rajouter des print dans la boucle et observer le comportement avec des listes de plus en plus grandes

def tri_stupide_print(L):
    n = len(L)
    # tant que ce n'est pas fini
    while not est_croissante(L):
        print(L)
        # choisir des indices au hasard
        i = randrange(n)
        j = randrange(n)
        if (i < j and L[i] > L[j]) or (j < i and L[j] > L[i]):
            x = L[i]
            L[i] = L[j]
            L[j] = x
    return L

from random import randint
N = 30 # faire varier
# liste aléatoire de N nombres pris entre 1 et 1000
L = [randint(1, 100) for _ in range(N)]
print("L =", L)
tri_stupide_print(L)

#%% exercice 8.1

# classique ! à savoir faire !
def compte(L, N):
    assert all(0 <= x and x <= N for x in L)
    n = len(L)
    C = [0] * (N+1)
    for i in range(n):
        x = L[i]
        C[x] = C[x] + 1
    return C

# test
L = [4, 2, 1, 5, 8, 9, 6, 5, 3, 7, 6, 3, 5, 4, 0, 2, 8, 3, 3, 4]
print(compte(L, 9))

#%% exercice 8.2

def tri_comptage(L):
    n = len(L)
    N = maximum(L)
    C = compte(L, N)
    M = [0] * n
    # recontruire la liste :
    # i désigne un accumulateurs d'indices dans L
    # j est un indice dans C
    i = 0
    for j in range(N+1):
        # mettre un nombre consécutifs C[j] de termes égaux à j
        for _ in range(C[j]):
            M[i] = j
            i = i + 1
        # ici i n'est pas remis à 0, on continue donc aux indices suivants !!
    return M

# test
L = [4, 2, 1, 5, 8, 9, 6, 5, 3, 7, 6, 3, 5, 4, 0, 2, 8, 3, 3, 4]
print(tri_comptage(L))

#%% exercice 9

def mediane_1(L):
    n = len(L)
    M = tri_comptage(L)
    # quand la liste est triée, la médiane est le nombre au milieu !
    # si le nombre d'éléments est pair, on choisit celui au milieu du côté gauche
    return M[(n-1)//2]

def mediane_2(L):
    n = len(L)
    N = maximum(L)
    C = compte(L, N)
    # accumulateurs pour le nombre d'éléments, et pour la position dans la liste
    S = 0
    j = 0
    while 2 * S < n:
        S = S + C[j]
        j = j + 1
    return j - 1

# test
L = [4, 2, 1, 5, 8, 9, 6, 5, 3, 7, 6, 3, 5, 4, 0, 2, 8, 3, 3, 4]
print(mediane_1(L))
print(mediane_2(L))
